/**********************************************************************
** Copyright (C) 2002 Edgar Hindemith.  All rights reserved.
**
** email: ed@dom.de
**
** This file is part of the qpPhoto picture editor.
**
** This file may be distributed and/or modified under the terms of the
** GNU General Public License version 2 as published by the Free Software
** Foundation and appearing in the file LICENSE.GPL included in the
** packaging of this file.
**
**********************************************************************/
#ifndef COLORDLGINCLUDED
#define COLORDLGINCLUDED

#include "ColorDialog.h"
#include "colorPicker.h"

class QColor;

class colorDlg : public ColorDialog
{
    Q_OBJECT
public:
    colorDlg( QWidget* parent = 0, const char* name = 0, bool modal = false, WFlags fl = 0 );
    ~colorDlg();
    QColor getColor(){ return selected; };
    void setType(bool gray = false);
    void setTypeRGB();
    void setColor(QColor color);
    void setColor();

public slots:
    void colorChanged();
    void rChanged(int r);
    void gChanged(int g);
    void bChanged(int b);

protected:
    QColor selected;
    int red;
    int green;
    int blue;
};

#endif // COLORDLGINCLUDED


