/**********************************************************************
** Copyright (C) 2002 Edgar Hindemith.  All rights reserved.
**
** email: ed@dom.de
**
** This file is part of the qpPhoto picture editor.
**
** This file may be distributed and/or modified under the terms of the
** GNU General Public License version 2 as published by the Free Software
** Foundation and appearing in the file LICENSE.GPL included in the
** packaging of this file.
**
**********************************************************************/
#ifndef COLORPICKERINCLUDED
#define COLORPICKERINCLUDED

#include <qlabel.h>
#include <qimage.h>

class QColor;

class colorPicker : public QLabel
{
    Q_OBJECT
public:
    colorPicker( QWidget* parent = 0, const char* name = 0, WFlags fl = 0 );
    ~colorPicker();
    void setType(bool gray = false);
    void setTypeRGB();
    QColor getColor(){ return selected; };

signals:
    void   mouseMoved();
    void   mousePressed();
    void   mouseReleased();
    void   colorChanged();

protected:
    QColor selected;
    void   mouseMoveEvent(QMouseEvent* mev);
    void   mousePressEvent(QMouseEvent* mev);
    void   mouseReleaseEvent(QMouseEvent* mev);
    void   calculateColor();
    int    mouse_x;
    int    mouse_y;
    bool   mouse_pressed;
    bool   isGray;
    bool   isRGB;

private:
    QImage grayimage;
    QImage indexed;
    QImage rgbImage;
};

#endif // COLORPICKERINCLUDED



