/**********************************************************************
** Copyright (C) 2002 Edgar Hindemith.  All rights reserved.
**
** email: ed@dom.de
**
** This file is part of the qpPhoto picture editor.
**
** This file may be distributed and/or modified under the terms of the
** GNU General Public License version 2 as published by the Free Software
** Foundation and appearing in the file LICENSE.GPL included in the
** packaging of this file.
**
**********************************************************************/
#include <qpushbutton.h>
#include <qcombobox.h>
#include <qspinbox.h>
#include <qpainter.h>
#include <qlabel.h>
#include <qdialog.h>
#include <qpe/fontdatabase.h>
#include <qstringlist.h>
#include <qtooltip.h>
#include <qbitmap.h>
#include <qimage.h>
#include "draw.h"
#include "colorDlg.h"
#include "NewPic.h"

/* XPM */
static const char* const x3[]={
"3 3 2 1",
". c None",
"# c #000000",
".#.",
"###",
".#."};

/* XPM */
static const char* const x5[]={
"5 5 2 1",
". c None",
"# c #000000",
".###.",
"#####",
"#####",
"#####",
".###."};

/* XPM */
static const char* const x7[]={
"7 7 2 1",
". c None",
"# c #000000",
"..###..",
".#####.",
"#######",
"#######",
"#######",
".#####.",
"..###.."};

/* XPM */
static const char* const x9[]={
"9 9 2 1",
". c None",
"# c #000000",
"...###...",
".#######.",
".#######.",
"#########",
"#########",
"#########",
".#######.",
".#######.",
"...###..."};

/* XPM */
static const char* const x11[]={
"11 11 2 1",
". c None",
"# c #000000",
"....###....",
"..#######..",
".#########.",
".#########.",
"###########",
"###########",
"###########",
".#########.",
".#########.",
"..#######..",
"....###...."};

/* XPM */
static const char* const x13[]={
"13 13 2 1",
". c None",
"# c #000000",
"....#####....",
"..#########..",
".###########.",
".###########.",
"#############",
"#############",
"#############",
"#############",
"#############",
".###########.",
".###########.",
"..#########..",
"....#####...."};

/* XPM */
static const char* const x7f[]={
"7 7 6 1",
". c None",
"d c #000000",
"c c #303030",
"b c #585858",
"a c #808080",
"# c #c1c1c1",
"..###..",
".#aba#.",
"#abcba#",
"#bcdcb#",
"#abcba#",
".#aba#.",
"..###.."};

/* XPM */
static const char* const x9f[]={
"9 9 6 1",
". c None",
"d c #000000",
"c c #303030",
"b c #585858",
"a c #a0a0a0",
"# c #c1c1c1",
"...###...",
".##aaa##.",
".#abbba#.",
"#abbcbba#",
"#abcdcba#",
"#abbcbba#",
".#abbba#.",
".##aaa##.",
"...###..."};

/* XPM */
static const char* const x11f[]={
"11 11 6 1",
". c None",
"d c #000000",
"c c #303030",
"b c #585858",
"a c #a0a0a0",
"# c #c1c1c1",
"....###....",
"..##aaa##..",
".#aabbbaa#.",
".#abcccba#.",
"#abccdccba#",
"#abcdddcba#",
"#abccdccba#",
".#abcccba#.",
".#aabbbaa#.",
"..##aaa##..",
"....###...."};

/* XPM */
static const char* const x13f[]={
"13 13 6 1",
". c None",
"d c #000000",
"c c #303030",
"b c #585858",
"a c #a0a0a0",
"# c #c1c1c1",
"....#####....",
"..###aaa###..",
".##aabbbaa##.",
".#abbcccbba#.",
"##abcdddcba##",
"#abcdddddcba#",
"#abcdddddcba#",
"#abcdddddcba#",
"##abcdddcba##",
".#abbcccbba#.",
".##aabbbaa##.",
"..###aaa###..",
"....#####...."};

/* XPM */
static const char* const q315[]={
"15 15 2 1",
". c None",
"# c #000000",
"...............",
"...............",
"...............",
"...............",
"...............",
"...............",
"......###......",
"......###......",
"......###......",
"...............",
"...............",
"...............",
"...............",
"...............",
"..............."};


/* XPM */
static const char* const x315[]={
"15 15 2 1",
". c None",
"# c #000000",
"...............",
"...............",
"...............",
"...............",
"...............",
"...............",
".......#.......",
"......###......",
".......#.......",
"...............",
"...............",
"...............",
"...............",
"...............",
"..............."};

/* XPM */
static const char* const x515[]={
"15 15 2 1",
". c None",
"# c #000000",
"...............",
"...............",
"...............",
"...............",
"...............",
"......###......",
".....#####.....",
".....#####.....",
".....#####.....",
"......###......",
"...............",
"...............",
"...............",
"...............",
"..............."};

/* XPM */
static const char* const x715[]={
"15 15 2 1",
". c None",
"# c #000000",
"...............",
"...............",
"...............",
"...............",
"......###......",
".....#####.....",
"....#######....",
"....#######....",
"....#######....",
".....#####.....",
"......###......",
"...............",
"...............",
"...............",
"..............."};

/* XPM */
static const char* const x915[]={
"15 15 2 1",
". c None",
"# c #000000",
"...............",
"...............",
"...............",
"......###......",
"....#######....",
"....#######....",
"...#########...",
"...#########...",
"...#########...",
"....#######....",
"....#######....",
"......###......",
"...............",
"...............",
"..............."};

/* XPM */
static const char* const x1115[]={
"15 15 2 1",
". c None",
"# c #000000",
"...............",
"...............",
"......###......",
"....#######....",
"...#########...",
"...#########...",
"..###########..",
"..###########..",
"..###########..",
"...#########...",
"...#########...",
"....#######....",
"......###......",
"...............",
"..............."};

/* XPM */
static const char* const x1315[]={
"15 15 2 1",
". c None",
"# c #000000",
"...............",
".....#####.....",
"...#########...",
"..###########..",
"..###########..",
".#############.",
".#############.",
".#############.",
".#############.",
".#############.",
"..###########..",
"..###########..",
"...#########...",
".....#####.....",
"..............."};

/* XPM */
static const char* const x7f15[]={
"15 15 6 1",
". c None",
"d c #000000",
"c c #303030",
"b c #585858",
"a c #808080",
"# c #c1c1c1",
"...............",
"...............",
"...............",
"...............",
"......###......",
".....#aba#.....",
"....#abcba#....",
"....#bcdcb#....",
"....#abcba#....",
".....#aba#.....",
"......###......",
"...............",
"...............",
"...............",
"..............."};

/* XPM */
static const char* const x9f15[]={
"15 15 6 1",
". c None",
"d c #000000",
"c c #303030",
"b c #585858",
"a c #a0a0a0",
"# c #c1c1c1",
"...............",
"...............",
"...............",
"......###......",
"....##aaa##....",
"....#abbba#....",
"...#abbcbba#...",
"...#abcdcba#...",
"...#abbcbba#...",
"....#abbba#....",
"....##aaa##....",
"......###......",
"...............",
"...............",
"..............."};

/* XPM */
static const char* const x11f15[]={
"15 15 6 1",
". c None",
"d c #000000",
"c c #303030",
"b c #585858",
"a c #a0a0a0",
"# c #c1c1c1",
"...............",
"...............",
"......###......",
"....##aaa##....",
"...#aabbbaa#...",
"...#abcccba#...",
"..#abccdccba#..",
"..#abcdddcba#..",
"..#abccdccba#..",
"...#abcccba#...",
"...#aabbbaa#...",
"....##aaa##....",
"......###......",
"...............",
"..............."};

/* XPM */
static const char* const x13f15[]={
"15 15 6 1",
". c None",
"d c #000000",
"c c #303030",
"b c #585858",
"a c #a0a0a0",
"# c #c1c1c1",
"...............",
".....#####.....",
"...###aaa###...",
"..##aabbbaa##..",
"..#abbcccbba#..",
".##abcdddcba##.",
".#abcdddddcba#.",
".#abcdddddcba#.",
".#abcdddddcba#.",
".##abcdddcba##.",
"..#abbcccbba#..",
"..##aabbbaa##..",
"...###aaa###...",
".....#####.....",
"..............."};

/* XPM */
static const char* const gradient_v[]={
"40 16 8 1",
". c #ffffff",
"f c #efefef",
"e c #c1c1c1",
"d c #a0a0a0",
"c c #808080",
"b c #585858",
"a c #303030",
"# c #000000",
"........................................",
"....################################....",
"....################################....",
"....aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa....",
"....aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa....",
"....bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb....",
"....bbbbbbbbbbbbbbbbbbbbbbbbbbbbbbbb....",
"....cccccccccccccccccccccccccccccccc....",
"....cccccccccccccccccccccccccccccccc....",
"....dddddddddddddddddddddddddddddddd....",
"....dddddddddddddddddddddddddddddddd....",
"....eeeeeeeeeeeeeeeeeeeeeeeeeeeeeeee....",
"....eeeeeeeeeeeeeeeeeeeeeeeeeeeeeeee....",
"....ffffffffffffffffffffffffffffffff....",
"....ffffffffffffffffffffffffffffffff....",
"........................................"};

/* XPM */
static const char* const gradient_h[]={
"40 16 8 1",
". c #ffffff",
"f c #000000",
"e c #303030",
"d c #585858",
"c c #808080",
"b c #a0a0a0",
"a c #c1c1c1",
"# c #efefef",
"........................................",
"....ffffeeeeddddccccbbbbaaaa####........",
"....ffffeeeeddddccccbbbbaaaa####........",
"....ffffeeeeddddccccbbbbaaaa####........",
"....ffffeeeeddddccccbbbbaaaa####........",
"....ffffeeeeddddccccbbbbaaaa####........",
"....ffffeeeeddddccccbbbbaaaa####........",
"....ffffeeeeddddccccbbbbaaaa####........",
"....ffffeeeeddddccccbbbbaaaa####........",
"....ffffeeeeddddccccbbbbaaaa####........",
"....ffffeeeeddddccccbbbbaaaa####........",
"....ffffeeeeddddccccbbbbaaaa####........",
"....ffffeeeeddddccccbbbbaaaa####........",
"....ffffeeeeddddccccbbbbaaaa####........",
"....ffffeeeeddddccccbbbbaaaa####........",
"........................................"};


/* XPM */
static const char* const sh_rect[]={
"40 16 2 1",
". c #ffffff",
"# c #000000",
"........................................",
"....################################....",
"....#..............................#....",
"....#..............................#....",
"....#..............................#....",
"....#..............................#....",
"....#..............................#....",
"....#..............................#....",
"....#..............................#....",
"....#..............................#....",
"....#..............................#....",
"....#..............................#....",
"....#..............................#....",
"....#..............................#....",
"....################################....",
"........................................"};

/* XPM */
static const char* const sh_frect[]={
"40 16 2 1",
". c #ffffff",
"# c #000000",
"........................................",
"....################################....",
"....################################....",
"....################################....",
"....################################....",
"....################################....",
"....################################....",
"....################################....",
"....################################....",
"....################################....",
"....################################....",
"....################################....",
"....################################....",
"....################################....",
"....################################....",
"........................................"};

/* XPM */
static const char* const sh_circle[]={
"40 16 2 1",
". c #ffffff",
"# c #000000",
"........................................",
".................######.................",
"................#......#................",
"...............#........#...............",
"..............#..........#..............",
".............#............#.............",
".............#............#.............",
".............#............#.............",
".............#............#.............",
".............#............#.............",
".............#............#.............",
"..............#..........#..............",
"...............#........#...............",
"................#......#................",
".................######.................",
"........................................"};

/* XPM */
static const char* const sh_fcircle[]={
"40 16 2 1",
". c #ffffff",
"# c #000000",
"........................................",
".................######.................",
"................########................",
"...............##########...............",
"..............############..............",
".............##############.............",
".............##############.............",
".............##############.............",
".............##############.............",
".............##############.............",
".............##############.............",
"..............############..............",
"...............##########...............",
"................########................",
".................######.................",
"........................................"};

/* XPM */
static const char* const sh_ellipse[]={
"40 16 2 1",
". c #ffffff",
"# c #000000",
"........................................",
"..............############..............",
"..........####............####..........",
".......###....................###.......",
"......#..........................#......",
".....#............................#.....",
"....#..............................#....",
"....#..............................#....",
"....#..............................#....",
"....#..............................#....",
".....#............................#.....",
"......#..........................#......",
".......###....................###.......",
"..........####............####..........",
"..............############..............",
"........................................"};

/* XPM */
static const char* const sh_fellipse[]={
"40 16 2 1",
". c #ffffff",
"# c #000000",
"........................................",
"..............############..............",
"..........####################..........",
".......##########################.......",
"......############################......",
".....##############################.....",
"....################################....",
"....################################....",
"....################################....",
"....################################....",
".....##############################.....",
"......############################......",
".......##########################.......",
"..........####################..........",
"..............############..............",
"........................................"};

/* XPM */
static const char* const fuzzy_select[]={
"40 16 5 1",
"b c #000000",
"c c #585858",
"a c #808080",
"# c #a0a0a0",
". c #ffffff",
"....................#.#.................",
"..................#.#.#.#...............",
".................#.##.##.#..............",
"..................#.#.#.#...............",
"...............######.######............",
"...............#...........#............",
"...............#####..######............",
".................##a#.#.#...............",
"................b#ac#.##.#..............",
"...............b#ac.#.#.#...............",
"..............b#ac..#.#.................",
".............b#ac...###.................",
"............b#ac........................",
"...........b#ac.........................",
"...........bac..........................",
"........................................"};

/* XPM */
static const char* const lc10[]={
"32 15 2 1",
"# c #000000",
". c #ffffff",
"................................",
"................................",
"................................",
"................................",
"................................",
"................................",
"................................",
"..############################..",
"................................",
"................................",
"................................",
"................................",
"................................",
"................................",
"................................"};

/* XPM */
static const char* const lc11[]={
"32 15 2 1",
"# c #000000",
". c #ffffff",
"................................",
"................................",
"...................##...........",
"...................#.##.........",
"...................#...##.......",
"...................#.....##.....",
"...................#.......##...",
"..##################........##..",
"...................#.......##...",
"...................#.....##.....",
"...................#...##.......",
"...................#.##.........",
"...................##...........",
"................................",
"................................"};

/* XPM */
static const char* const lc12[]={
"32 15 2 1",
"# c #000000",
". c #ffffff",
"................................",
"................................",
"...........##......##...........",
".........##.#......#.##.........",
".......##...#......#...##.......",
".....##.....#......#.....##.....",
"...##.......#......#.......##...",
"..##........########........##..",
"...##.......#......#.......##...",
".....##.....#......#.....##.....",
".......##...#......#...##.......",
".........##.#......#.##.........",
"...........##......##...........",
"................................",
"................................"};

/* XPM */
static const char* const lc13[]={
"32 15 2 1",
"# c #000000",
". c #ffffff",
"................................",
"................................",
"................................",
"..#.............................",
"..#.............................",
"..#.............................",
"..#.............................",
"..############################..",
"..#.............................",
"..#.............................",
"..#.............................",
"..#.............................",
"................................",
"................................",
"................................"};

/* XPM */
static const char* const lc14[]={
"32 15 2 1",
"# c #000000",
". c #ffffff",
"................................",
"................................",
"................................",
"..#..........................#..",
"..#..........................#..",
"..#..........................#..",
"..#..........................#..",
"..############################..",
"..#..........................#..",
"..#..........................#..",
"..#..........................#..",
"..#..........................#..",
"................................",
"................................",
"................................"};

/* XPM */
static const char* const lc15[]={
"32 15 2 1",
"# c #000000",
". c #ffffff",
"................................",
"................................",
"...................##...........",
"..#................#.##.........",
"..#................#...##.......",
"..#................#.....##.....",
"..#................#.......##...",
"..##################........##..",
"..#................#.......##...",
"..#................#.....##.....",
"..#................#...##.......",
"..#................#.##.........",
"...................##...........",
"................................",
"................................"};




Draw::Draw( QWidget* parent = 0, const char* name = 0, WFlags fl = 0 )
:DrawWidget(parent, name, fl)
{
    /*currentTool = dtNull;
    currentShape = shRect;
    currentBrush = bsSquare;
    currentErazorBrush = bsSquare;
    currentOp = 0;
    currentPicker = 0;
    currentLineCap = 0;
    currentPenStyle = 0;
    brushSize = 1;
    erazorSize = 1;
    depth = 32;
    gray = false;*/
    FontDatabase fdb;
    availFonts = fdb.families();


    dv = new DrawView(GrFrame, "dv");
    dv->setGeometry( QRect( 1, 1, 210, 210) );

    dv->font.setFamily(availFonts[0]);
    dv->font.setPointSize(12);
    dv->font.setBold(false);
    dv->font.setItalic(false);
    dv->font.setUnderline(false);

    /*Bold->hide();
    Italic->hide();
    Underline->hide();
    Selection->hide();
    Size->hide();
    Operation->hide();
    TypeLabel->hide();
    SizeLabel->hide();
    PbCursor->setEnabled(false);*/
    QToolTip::add( FgColor, "foreground: #000000" );
    QToolTip::add( BgColor, "background: #ffffff" );
    init();

    connect( FgColor, SIGNAL(clicked()), this, SLOT(selectFgColor()));
    connect( BgColor, SIGNAL(clicked()), this, SLOT(selectBgColor()));

    connect( PbCursor, SIGNAL(clicked()), this, SLOT(pbCursorPressed()));
    connect( PbBrush, SIGNAL(clicked()), this, SLOT(pbBrushPressed()));
    connect( PbLine, SIGNAL(clicked()), this, SLOT(pbLinePressed()));
    connect( PbPolygon, SIGNAL(clicked()), this, SLOT(pbPolygonPressed()));
    connect( PbSelect, SIGNAL(clicked()), this, SLOT(pbSelectPressed()));
    connect( PbText, SIGNAL(clicked()), this, SLOT(pbTextPressed()));
    connect( PbFill, SIGNAL(clicked()), this, SLOT(pbFillPressed()));
    connect( PbPicker, SIGNAL(clicked()), this, SLOT(pbPickerPressed()));
    connect( PbErazor, SIGNAL(clicked()), this, SLOT(pbErazorPressed()));

    connect( this, SIGNAL(changeTool(int)), this, SLOT(toolChanged(int)));

    connect( Bold, SIGNAL(clicked()), this, SLOT(boldPressed()));
    connect( Italic, SIGNAL(clicked()), this, SLOT(italicPressed()));
    connect( Underline, SIGNAL(clicked()), this, SLOT(ulinePressed()));

    connect( Selection, SIGNAL(activated(int)), this, SLOT(selChanged(int)));
    connect( Size, SIGNAL(valueChanged(int)), this, SLOT(sizeChanged(int)));
    connect( Operation, SIGNAL(activated(int)), this, SLOT(opChanged(int)));

    connect( dv, SIGNAL(colorPicked(QColor)), this, SLOT(setColor(QColor)));
    connect( dv, SIGNAL(selectionChanged()), this, SLOT(maskChanged()));
    connect( dv, SIGNAL(colorStateChanged(int,bool)), this, SLOT(colorStateChanged(int,bool)));
    connect( dv, SIGNAL(mouseMoved()), this, SLOT(statusChanged()));
}

Draw::~Draw()
{

}

void Draw::init()
{
    currentTool = dtNull;
    currentShape = shRect;
    currentBrush = bsSquare;
    currentErazorBrush = bsSquare;
    currentOp = 0;
    currentPicker = 0;
    currentLineCap = 0;
    currentPenStyle = 0;
    brushSize = 1;
    erazorSize = 1;
    depth = 32;
    gray = false;
    Bold->hide();
    Italic->hide();
    Underline->hide();
    Selection->clear();
    Selection->hide();
    Size->hide();
    Operation->clear();
    Operation->hide();
    TypeLabel->hide();
    SizeLabel->hide();

    if(Italic->isOn())Italic->setOn(false);
    if(Bold->isOn())Bold->setOn(false);
    if(Underline->isOn())Underline->setOn(false);
    if(PbCursor->isOn())PbCursor->setOn(false);
    if(PbBrush->isOn())PbBrush->setOn(false);
    if(PbLine->isOn())PbLine->setOn(false);
    if(PbPolygon->isOn())PbPolygon->setOn(false);
    if(PbSelect->isOn())PbSelect->setOn(false);
    if(PbText->isOn())PbText->setOn(false);
    if(PbFill->isOn())PbFill->setOn(false);
    if(PbPicker->isOn())PbPicker->setOn(false);
    if(PbErazor->isOn())PbErazor->setOn(false);

    PbCursor->setEnabled(false);
    dv->fgColor.setRgb(0, 0, 0);
    dv->bgColor.setRgb(255, 255, 255);
    QPalette pal = FgColor->palette();
    pal.setColor(QPalette::Active, QColorGroup::Button, dv->fgColor);
    pal.setColor(QPalette::Inactive, QColorGroup::Button, dv->fgColor);
    FgColor->setPalette(pal);
    QString tt;
    tt.sprintf("foreground: #%02x%02x%02x", dv->fgColor.red(), dv->fgColor.green(), dv->fgColor.blue());
    QToolTip::remove( FgColor );
    QToolTip::add( FgColor, tt );
    setBrush();
    pal = BgColor->palette();
    pal.setColor(QPalette::Active, QColorGroup::Button, dv->bgColor);
    pal.setColor(QPalette::Inactive, QColorGroup::Button, dv->bgColor);
    BgColor->setPalette(pal);
    tt.sprintf("background: #%02x%02x%02x", dv->bgColor.red(), dv->bgColor.green(), dv->bgColor.blue());
    QToolTip::remove( BgColor );
    QToolTip::add( BgColor, tt );
    setErazor();
}

void Draw::setBrush()
{
    QPixmap image;
    QPixmap mask;
    switch(currentBrush){
        case bsSquare:
        dv->setBrushImage(brushSize);
        break;
        case bsCircle3:
        mask = QPixmap(( const char** )x3);
        dv->setBrushImage(mask);
        break;
        case bsCircle5:
        mask = QPixmap(( const char** )x5);
        dv->setBrushImage(mask);
        break;
        case bsCircle7:
        mask = QPixmap(( const char** )x7);
        dv->setBrushImage(mask);
        break;
        case bsCircle7f:
        image = QPixmap(( const char** )x7f);
        mask = QPixmap(( const char** )x7);
        dv->setBrushImage(image, mask);
        break;
        case bsCircle9:
        mask = QPixmap(( const char** )x9);
        dv->setBrushImage(mask);
        break;
        case bsCircle9f:
        image = QPixmap(( const char** )x9f);
        mask = QPixmap(( const char** )x9);
        dv->setBrushImage(image, mask);
        break;
        case bsCircle11:
        mask = QPixmap(( const char** )x11);
        dv->setBrushImage(mask);
        break;
        case bsCircle11f:
        image = QPixmap(( const char** )x11f);
        mask = QPixmap(( const char** )x11);
        dv->setBrushImage(image, mask);
        break;
        case bsCircle13:
        mask = QPixmap(( const char** )x13);
        dv->setBrushImage(mask);
        break;
        case bsCircle13f:
        image = QPixmap(( const char** )x13f);
        mask = QPixmap(( const char** )x13);
        dv->setBrushImage(image, mask);
        break;
    }
}

void Draw::setErazor()
{
    QPixmap image;
    QPixmap mask;
    switch(currentErazorBrush){
        case bsSquare:
        dv->setErazorImage(erazorSize);
        break;
        case bsCircle3:
        mask = QPixmap(( const char** )x3);
        dv->setErazorImage(mask);
        break;
        case bsCircle5:
        mask = QPixmap(( const char** )x5);
        dv->setErazorImage(mask);
        break;
        case bsCircle7:
        mask = QPixmap(( const char** )x7);
        dv->setErazorImage(mask);
        break;
        case bsCircle7f:
        image = QPixmap(( const char** )x7f);
        mask = QPixmap(( const char** )x7);
        dv->setErazorImage(image, mask);
        break;
        case bsCircle9:
        mask = QPixmap(( const char** )x9);
        dv->setErazorImage(mask);
        break;
        case bsCircle9f:
        image = QPixmap(( const char** )x9f);
        mask = QPixmap(( const char** )x9);
        dv->setErazorImage(image, mask);
        break;
        case bsCircle11:
        mask = QPixmap(( const char** )x11);
        dv->setErazorImage(mask);
        break;
        case bsCircle11f:
        image = QPixmap(( const char** )x11f);
        mask = QPixmap(( const char** )x11);
        dv->setErazorImage(image, mask);
        break;
        case bsCircle13:
        mask = QPixmap(( const char** )x13);
        dv->setErazorImage(mask);
        break;
        case bsCircle13f:
        image = QPixmap(( const char** )x13f);
        mask = QPixmap(( const char** )x13);
        dv->setErazorImage(image, mask);
        break;
    }
}

void Draw::statusChanged()
{
    QString status = "";
    if(dv->isMousePressed()){
        QPoint p1,p2;
        int w, h;
        switch(currentTool){
            case dtBrush:
            case dtErazor:
                p1 = dv->getPos();
                status.sprintf("x: %d y: %d", p1.x(), p1.y());
                break;
            case dtLine:
                p1 = dv->getTrackerPos();
                p2 = dv->getPos();
                status.sprintf("x1: %d y1: %d x2: %d y2: %d", p1.x(), p1.y(), p2.x(), p2.y());
                break;
            case dtPolygon:
            case dtSelect:
            case dtText:
                p1 = dv->getTrackerPos();
                p2 = dv->getPos();
                w = p2.x() - p1.x();
                h = p2.y() - p1.y();
                if( (currentTool == dtPolygon && (dv->currentShape == shCircle || dv->currentShape == shFilledCircle)) ||
                    (currentTool == dtSelect && dv->currentSelType == selCircle) ){
                    int x = p1.x() + w/2;
                    int y = p1.y() + h/2;
                    status.sprintf("cx: %d cy: %d r: %d", x, y, (w > h)?h:w);
                } else {
                    status.sprintf("x: %d y: %d w: %d h: %d", p1.x(), p1.y(), w, h);
                }
                break;
            case dtFill:
                if(dv->currentFill == fillVGradient){
                    p1 = dv->getTrackerPos();
                    p2 = dv->getPos();
                    status.sprintf("y1: %d y2: %d", p1.y(), p2.y());
                } else if(dv->currentFill == fillVGradient){
                    p1 = dv->getTrackerPos();
                    p2 = dv->getPos();
                    status.sprintf("x1: %d x2: %d", p1.x(), p2.x());
                }
                break;
            case dtCursor:
                PbCursor->toggle();
                break;
            case dtPicker:
            case dtNull:
            default:
                break;
        }
    } else {
        if(currentTool == dtPicker){
            QPoint p = dv->getPos();
            QColor picked = dv->getColorAt(p.x(), p.y());
            status.sprintf("%02x%02x%02x", picked.red(), picked.green(), picked.blue());
        } else if(currentTool != dtNull){
            QPoint p = dv->getPos();
            status.sprintf("x: %d y: %d", p.x(), p.y());
        }
    }
    StatusLine->setText(status);
}

void Draw::colorStateChanged(int d, bool g)
{
    if(d == 1){
            dv->fgColor.setRgb(0, 0, 0);
            dv->bgColor.setRgb(255, 255, 255);
            QPalette pal = FgColor->palette();
            pal.setColor(QPalette::Active, QColorGroup::Button, dv->fgColor);
            pal.setColor(QPalette::Inactive, QColorGroup::Button, dv->fgColor);
            FgColor->setPalette(pal);
            QString tt;
            tt.sprintf("foreground: #%02x%02x%02x", dv->fgColor.red(), dv->fgColor.green(), dv->fgColor.blue());
            QToolTip::remove( FgColor );
            QToolTip::add( FgColor, tt );
            setBrush();
            pal = BgColor->palette();
            pal.setColor(QPalette::Active, QColorGroup::Button, dv->bgColor);
            pal.setColor(QPalette::Inactive, QColorGroup::Button, dv->bgColor);
            BgColor->setPalette(pal);
            tt.sprintf("background: #%02x%02x%02x", dv->bgColor.red(), dv->bgColor.green(), dv->bgColor.blue());
            QToolTip::remove( BgColor );
            QToolTip::add( BgColor, tt );
            setErazor();
    } else if(d == 8){
            if(g){
                int gr = (dv->fgColor.red()*11 + dv->fgColor.green()*16 + dv->fgColor.blue()*5)/32;
                dv->fgColor.setRgb(gr, gr, gr);
                gr = (dv->bgColor.red()*11 + dv->bgColor.green()*16 + dv->bgColor.blue()*5)/32;
                dv->bgColor.setRgb(gr, gr, gr);
                QPalette pal = FgColor->palette();
                pal.setColor(QPalette::Active, QColorGroup::Button, dv->fgColor);
                pal.setColor(QPalette::Inactive, QColorGroup::Button, dv->fgColor);
                FgColor->setPalette(pal);
                QString tt;
                tt.sprintf("foreground: #%02x%02x%02x", dv->fgColor.red(), dv->fgColor.green(), dv->fgColor.blue());
                QToolTip::remove( FgColor );
                QToolTip::add( FgColor, tt );
                setBrush();
                pal = BgColor->palette();
                pal.setColor(QPalette::Active, QColorGroup::Button, dv->bgColor);
                pal.setColor(QPalette::Inactive, QColorGroup::Button, dv->bgColor);
                BgColor->setPalette(pal);
                tt.sprintf("background: #%02x%02x%02x", dv->bgColor.red(), dv->bgColor.green(), dv->bgColor.blue());
                QToolTip::remove( BgColor );
                QToolTip::add( BgColor, tt );
                setErazor();
            }
    }
    depth = d;
    gray = g;
}

void Draw::selectFgColor()
{
    if(depth > 1){
        colorDlg* cd = new colorDlg(this, "foreground color", true);
        if(depth >= 24){
            cd->setTypeRGB();
        } else {
            cd->setType(gray);
        }
        cd->setColor(dv->fgColor);
        int result = cd->exec();
        if(result == QDialog::Accepted){
            dv->fgColor = cd->getColor();
            dv->brush.setColor(dv->fgColor);
            dv->pen.setColor(dv->fgColor);
            dv->currentLineCap = currentLineCap;
            QPalette pal = FgColor->palette();
            pal.setColor(QPalette::Active, QColorGroup::Button, dv->fgColor);
            pal.setColor(QPalette::Inactive, QColorGroup::Button, dv->fgColor);
            FgColor->setPalette(pal);
            QString tt;
            tt.sprintf("foreground: #%02x%02x%02x", dv->fgColor.red(), dv->fgColor.green(), dv->fgColor.blue());
            QToolTip::remove( FgColor );
            QToolTip::add( FgColor, tt );
            setBrush();
            opChanged(currentOp);
        }
        delete cd;
    }
}

void Draw::selectBgColor()
{
    if(depth > 1){
        colorDlg* cd = new colorDlg(this, "background color", true);
        if(depth >= 24){
            cd->setTypeRGB();
        } else {
            cd->setType(gray);
        }
        cd->setColor(dv->bgColor);
        int result = cd->exec();
        if(result == QDialog::Accepted){
            dv->bgColor = cd->getColor();
            QPalette pal = BgColor->palette();
            pal.setColor(QPalette::Active, QColorGroup::Button, dv->bgColor);
            pal.setColor(QPalette::Inactive, QColorGroup::Button, dv->bgColor);
            BgColor->setPalette(pal);
            QString tt;
            tt.sprintf("background: #%02x%02x%02x", dv->bgColor.red(), dv->bgColor.green(), dv->bgColor.blue());
            QToolTip::remove( BgColor );
            QToolTip::add( BgColor, tt );
            setErazor();
            opChanged(currentOp);
        }
        delete cd;
    }
}

void Draw::setColor(QColor c)
{
    if(currentPicker == 0){
        dv->fgColor = c;
        dv->brush.setColor(dv->fgColor);
        dv->pen.setColor(dv->fgColor);
        dv->currentLineCap = currentLineCap;
        QPalette pal = FgColor->palette();
        pal.setColor(QPalette::Active, QColorGroup::Button, dv->fgColor);
        pal.setColor(QPalette::Inactive, QColorGroup::Button, dv->fgColor);
        FgColor->setPalette(pal);
        QString tt;
        tt.sprintf("foreground: #%02x%02x%02x", dv->fgColor.red(), dv->fgColor.green(), dv->fgColor.blue());
        QToolTip::remove( FgColor );
        QToolTip::add( FgColor, tt );
        setBrush();
        opChanged(currentOp);
    } else {
        dv->bgColor = c;
        QPalette pal = BgColor->palette();
        pal.setColor(QPalette::Active, QColorGroup::Button, dv->bgColor);
        pal.setColor(QPalette::Inactive, QColorGroup::Button, dv->bgColor);
        BgColor->setPalette(pal);
        QString tt;
        tt.sprintf("background: #%02x%02x%02x", dv->bgColor.red(), dv->bgColor.green(), dv->bgColor.blue());
        QToolTip::remove( BgColor );
        QToolTip::add( BgColor, tt );
        setErazor();
        opChanged(currentOp);
    }
}

void Draw::maskChanged()
{
    PbCursor->setEnabled(!dv->isSelectionEmpty());
}

void Draw::boldPressed()
{
    bold = Bold->isOn();
    dv->font.setBold(bold);
}

void Draw::italicPressed()
{
    italic = Italic->isOn();
    dv->font.setItalic(italic);
}

void Draw::ulinePressed()
{
    underline = Underline->isOn();
    dv->font.setUnderline(underline);
}

void Draw::selChanged(int index)
{
    index = index;
    if(currentTool == dtLine || currentTool == dtBrush || currentTool == dtErazor){
        if(index >= 1){
            if(Size->isEnabled()){
                Size->setDisabled(true);
                switch(currentTool){
                    case dtBrush:
                    brushSize = 1;
                    break;
                    case dtErazor:
                    erazorSize = 1;
                    break;
                    case dtLine:
                    dv->pen.setWidth(1);
                    break;
                }
            }
        } else {
            if(!Size->isEnabled()){
                Size->setEnabled(true);
                switch(currentTool){
                    case dtBrush:
                    brushSize = Size->value();
                    break;
                    case dtErazor:
                    erazorSize = Size->value();
                    break;
                    case dtLine:
                    dv->pen.setWidth(Size->value());
                    break;
                }
            }
        }
    }
    //QPixmap image;
    switch(currentTool){
        case dtLine:
            switch(index){
                case 0:
                dv->pen.setStyle(SolidLine);
                break;
                case 1:
                dv->pen.setStyle(DashLine);
                break;
                case 2:
                dv->pen.setStyle(DotLine);
                break;
                case 3:
                dv->pen.setStyle(DashDotLine);
                break;
                case 4:
                dv->pen.setStyle(DashDotDotLine);
                break;
            }
            currentPenStyle = index;
            break;
        case dtText:
            dv->font.setFamily(availFonts[index]);
            break;
        case dtSelect:
            dv->currentSelType = index;
            break;
        case dtPolygon:
            dv->currentShape = index;
            break;
        case dtFill:
            dv->currentFill = index;
            break;
        case dtPicker:
            currentPicker = index;
            break;
        case dtBrush:
            currentBrush = index;
            setBrush();
            opChanged(currentOp);
            break;
        case dtErazor:
            currentErazorBrush = index;
            setErazor();
            opChanged(currentOp);
            break;
        default:
            break;
    }
}

void Draw::sizeChanged(int value)
{
    switch(currentTool){
        case dtLine:
            dv->pen.setWidth(value);
            break;
        case dtText:
            dv->font.setPointSize(value);
            break;
        case dtBrush:
            brushSize = value;
            setBrush();
            opChanged(currentOp);
            break;
        case dtErazor:
            erazorSize = value;
            setErazor();
            opChanged(currentOp);
            break;
        default:
            break;
    }
}

void Draw::opChanged(int index)
{
    switch(currentTool){
        case dtLine:
            dv->currentLineCap = index;
            currentLineCap = index;
            break;
        case dtSelect:
            dv->currentSelOp = index;
            break;
        case dtBrush:
        case dtErazor:
            switch(index){
                case 0:
                dv->currentRO = DrawView::roSTD;
                dv->currentROC = DrawView::rocALWAYS;
                break;
                case 1:
                dv->currentRO = DrawView::roAND;
                dv->currentROC = DrawView::rocALWAYS;
                break;
                case 2:
                dv->currentRO = DrawView::roOR;
                dv->currentROC = DrawView::rocALWAYS;
                break;
                case 3:
                dv->currentRO = DrawView::roCP;
                dv->currentROC = DrawView::rocALWAYS;
                break;
                case 4:
                dv->currentRO = DrawView::roADD;
                dv->currentROC = DrawView::rocALWAYS;
                break;
                case 5:
                dv->currentRO = DrawView::roSUB;
                dv->currentROC = DrawView::rocALWAYS;
                break;
                case 6:
                dv->currentRO = DrawView::roLIGHT;
                dv->currentROC = DrawView::rocALWAYS;
                break;
                case 7:
                dv->currentRO = DrawView::roDARK;
                dv->currentROC = DrawView::rocALWAYS;
                break;
                case 8:
                dv->currentRO = DrawView::roAVG;
                dv->currentROC = DrawView::rocALWAYS;
                break;
                case 9:
                dv->currentRO = DrawView::roCP;
                dv->currentROC = DrawView::rocIFGT;
                break;
                case 10:
                dv->currentRO = DrawView::roCP;
                dv->currentROC = DrawView::rocIFLT;
                break;
            }
            currentOp = index;
            break;
        default:
            break;
    }
}

void Draw::hideProps(int tool)
{
    if(tool == dtText){
        Bold->hide();
        Italic->hide();
        Underline->hide();
    }
    if(tool == dtText || tool == dtBrush || tool == dtLine || tool == dtPolygon || tool == dtErazor || tool == dtFill || tool == dtSelect || tool == dtPicker){
        Selection->clear();
        Selection->hide();
        TypeLabel->hide();
    }
    if(tool == dtText || tool == dtBrush || tool == dtLine || tool == dtErazor){
        Size->hide();
        SizeLabel->hide();
    }
    if(tool == dtBrush || tool == dtLine || tool == dtErazor || tool == dtSelect){
        Operation->clear();
        Operation->hide();
    }
}

void Draw::showProps(int tool)
{
    if(tool == dtText){
        Bold->show();
        Italic->show();
        Underline->show();
    }
    if(tool == dtText || tool == dtBrush || tool == dtLine || tool == dtPolygon || tool == dtErazor || tool == dtFill || tool == dtSelect || tool == dtPicker){
        if(tool == dtText){
            Selection->insertStringList(availFonts);
            TypeLabel->setText("Font");
            for(uint i = 0; i < availFonts.count(); i++ ){
                if(dv->font.family() == availFonts[i]){
                    Selection->setCurrentItem(i);
                    break;
                }
            }
        } else if(tool == dtBrush || tool == dtErazor){
            QPixmap image0( ( const char** ) q315 );
            QPixmap image01( ( const char** ) x315 );
            QPixmap image02( ( const char** ) x515 );
            QPixmap image03( ( const char** ) x715 );
            QPixmap image04( ( const char** ) x915 );
            QPixmap image05( ( const char** ) x1115 );
            QPixmap image06( ( const char** ) x1315 );
            QPixmap image07( ( const char** ) x7f15 );
            QPixmap image08( ( const char** ) x9f15 );
            QPixmap image09( ( const char** ) x11f15 );
            QPixmap image10( ( const char** ) x13f15 );
            Selection->insertItem(image0, "square", bsSquare);
            Selection->insertItem(image01, "circle 3", bsCircle3);
            Selection->insertItem(image02, "circle 5", bsCircle5);
            Selection->insertItem(image03, "circle 7", bsCircle7);
            Selection->insertItem(image04, "circle 9", bsCircle9);
            Selection->insertItem(image05, "circle 11", bsCircle11);
            Selection->insertItem(image06, "circle 13", bsCircle13);
            Selection->insertItem(image07, "circle 7f", bsCircle7f);
            Selection->insertItem(image08, "circle 9f", bsCircle9f);
            Selection->insertItem(image09, "circle 11f", bsCircle11f);
            Selection->insertItem(image10, "circle 13f", bsCircle13f);
            if(tool == dtBrush){
                Selection->setCurrentItem(currentBrush);
            } else {
                Selection->setCurrentItem(currentErazorBrush);
            }
            TypeLabel->setText("Type");
        } else if(tool == dtPolygon){
            QPixmap image0( ( const char** ) sh_rect );
            QPixmap image01( ( const char** ) sh_frect );
            QPixmap image02( ( const char** ) sh_circle );
            QPixmap image03( ( const char** ) sh_fcircle );
            QPixmap image04( ( const char** ) sh_ellipse );
            QPixmap image05( ( const char** ) sh_fellipse );
            Selection->insertItem(image0, "", shRect);
            Selection->insertItem(image01, "", shFilledRect);
            Selection->insertItem(image02, "", shCircle);
            Selection->insertItem(image03, "", shFilledCircle);
            Selection->insertItem(image04, "", shEllipse);
            Selection->insertItem(image05, "", shFilledEllipse);
            Selection->setCurrentItem(dv->currentShape);
            TypeLabel->setText("Shape");
        } else if(tool == dtSelect){
            QPixmap image0( ( const char** ) sh_rect );
            QPixmap image01( ( const char** ) sh_circle );
            QPixmap image02( ( const char** ) sh_ellipse );
            QPixmap image03( ( const char** ) fuzzy_select );
            Selection->insertItem(image0, "", selRect);
            Selection->insertItem(image01, "", selCircle);
            Selection->insertItem(image02, "", selEllipse);
            Selection->insertItem(image03, "", selArea);
            Selection->setCurrentItem(dv->currentSelType);
            TypeLabel->setText("Type");
        } else if(tool == dtFill){
            QPixmap image0( ( const char** ) sh_frect );
            QPixmap image01( ( const char** ) gradient_h );
            QPixmap image02( ( const char** ) gradient_v );
            QPixmap image03( ( const char** ) fuzzy_select );
            Selection->insertItem(image0, "", fillSolid);
            Selection->insertItem(image01, "", fillHGradient);
            Selection->insertItem(image02, "", fillVGradient);
            Selection->insertItem(image03, "", fillArea);
            Selection->setCurrentItem(dv->currentFill);
            TypeLabel->setText("Type");
        } else if(tool == dtPicker){
            Selection->insertItem("foreground", 0);
            Selection->insertItem("background", 1);
            Selection->setCurrentItem(currentPicker);
            TypeLabel->setText("Type");
        } else if(tool == dtLine){
            QPainter painter;
            QPen pen(black, 1);
            QPixmap image0(50, 16);
            QPixmap image01(50, 16);
            QPixmap image02(50, 16);
            QPixmap image03(50, 16);
            QPixmap image04(50, 16);

            image0.fill();
            image01.fill();
            image02.fill();
            image03.fill();
            image04.fill();

            painter.begin(&image0);
            painter.setPen(pen);
            painter.drawLine(4, 8, 46, 8);
            painter.end();

            pen.setStyle(DashLine);

            painter.begin(&image01);
            painter.setPen(pen);
            painter.drawLine(4, 8, 46, 8);
            painter.end();

            pen.setStyle(DotLine);

            painter.begin(&image02);
            painter.setPen(pen);
            painter.drawLine(4, 8, 46, 8);
            painter.end();

            pen.setStyle(DashDotLine);

            painter.begin(&image03);
            painter.setPen(pen);
            painter.drawLine(4, 8, 46, 8);
            painter.end();

            pen.setStyle(DashDotDotLine);

            painter.begin(&image04);
            painter.setPen(pen);
            painter.drawLine(4, 8, 46, 8);
            painter.end();

            Selection->insertItem(image0, "", 0);
            Selection->insertItem(image01, "", 1);
            Selection->insertItem(image02, "", 2);
            Selection->insertItem(image03, "", 3);
            Selection->insertItem(image04, "", 4);
            Selection->setCurrentItem(currentPenStyle);
            TypeLabel->setText("Style");
        }
        Selection->show();
        TypeLabel->show();
    }
    if(tool == dtText || tool == dtBrush || tool == dtLine || tool == dtErazor){
        if(!Size->isEnabled()){
            Size->setEnabled(true);
        }
        if(tool == dtText){
            Size->setMinValue(6);
            Size->setMaxValue(24);
            Size->setValue(dv->font.pointSize());
        } else if(tool == dtBrush || tool == dtLine || tool == dtErazor){
            Size->setMinValue(1);
            Size->setMaxValue(15);
            switch(tool){
                case dtBrush:
                Size->setValue(brushSize);
                break;
                case dtErazor:
                Size->setValue(erazorSize);
                break;
                case dtLine:
                Size->setValue(dv->pen.width());
                break;
            }
            if(Selection->currentItem() >= 1){
                Size->setDisabled(true);
            }
        }
        Size->show();
        SizeLabel->show();
    }
    if(tool == dtBrush || tool == dtLine || tool == dtErazor || tool == dtSelect){
        if(tool == dtBrush || tool == dtErazor){
            Operation->insertItem("standard", 0);
            Operation->insertItem("and", 1);
            Operation->insertItem("or", 2);
            Operation->insertItem("copy", 3);
            Operation->insertItem("add", 4);
            Operation->insertItem("sub", 5);
            Operation->insertItem("light", 6);
            Operation->insertItem("dark", 7);
            Operation->insertItem("avg", 8);
            Operation->insertItem("if gt", 9);
            Operation->insertItem("if lt", 10);
            Operation->setCurrentItem(currentOp);
        } else if(tool == dtSelect){
            Operation->insertItem("replace", 0);
            Operation->insertItem("add", 1);
            Operation->insertItem("subtract", 2);
            Operation->setCurrentItem(dv->currentSelOp);
        } else {
            QPixmap image0( ( const char** ) lc10 );
            QPixmap image01( ( const char** ) lc11 );
            QPixmap image02( ( const char** ) lc12 );
            QPixmap image03( ( const char** ) lc13 );
            QPixmap image04( ( const char** ) lc14 );
            QPixmap image05( ( const char** ) lc15 );
            Operation->insertItem(image0, "", 0);
            Operation->insertItem(image01, "", 1);
            Operation->insertItem(image02, "", 2);
            Operation->insertItem(image03, "", 3);
            Operation->insertItem(image04, "", 4);
            Operation->insertItem(image05, "", 5);
            Operation->setCurrentItem(dv->currentLineCap);
        }
        Operation->show();
    }
}

void Draw::toolChanged(int tool)
{
    if(tool != currentTool){
        switch(currentTool){
            case dtBrush:
                PbBrush->toggle();
                break;
            case dtLine:
                PbLine->toggle();
                break;
            case dtPolygon:
                PbPolygon->toggle();
                break;
            case dtSelect:
                PbSelect->toggle();
                break;
            case dtText:
                PbText->toggle();
                break;
            case dtFill:
                PbFill->toggle();
                break;
            case dtErazor:
                PbErazor->toggle();
                break;
            case dtPicker:
                PbPicker->toggle();
                break;
            case dtCursor:
                PbCursor->toggle();
                break;
            case dtNull:
            default:
                break;
        }
        hideProps(currentTool);
        currentTool = tool;
        dv->currentTool = tool;
        showProps(tool);
    } else {
        hideProps(currentTool);
        currentTool = dtNull;
        showProps(dtNull);
    }
}



