
        /**********************************************************************
** Copyright (C) 2002 Edgar Hindemith.  All rights reserved.
**
** email: ed@dom.de
**
** This file is part of the qpPhoto picture editor.
**
** This file may be distributed and/or modified under the terms of the
** GNU General Public License version 2 as published by the Free Software
** Foundation and appearing in the file LICENSE.GPL included in the
** packaging of this file.
**
**********************************************************************/
#ifndef SAVEASDLGINCLUDED
#define SAVEASDLGINCLUDED

#include "SaveAs.h"

class QColor;

class saveAsDlg : public SaveAs
{
    Q_OBJECT
public:
    saveAsDlg( QWidget* parent = 0, const char* name = 0, bool modal = false, WFlags fl = 0 );
    ~saveAsDlg();
    QString getName(){ return name; };
    QString getType(){ return type; };
    QString getMimeType(){ return mimeType; };
    int getQuality(){ return quality; };
    void setName(const QString& n);
    bool setType(const QString& t);
    bool setMimeType(const QString& t);
    void setDepth(int d, bool g = false);
    void setQuality(int q);
    const char* format();
    const char* extension();

public slots:
    void nameChanged(const QString &);
    void typeChanged(const QString &);
    void qualityChanged(int);

protected:
    QString name;
    QString type;
    QString mimeType;
    int quality;
    int depth;
    bool gray;
};

#endif // SAVEASDLGINCLUDED


